/***************************************************************************
                          interface.h  -  description
                             -------------------
    begin                : Wed Mar 14 2001
    copyright            : (C) 2001 by Franck Ladurelle
    email                : ladurelf@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _INTERFACE_H_
#define _INTERFACE_H_

#include "global.h"
#include "exceptions.h"
#include "misc.h"

#define MSGBOX_YES           1
#define MSGBOX_NO            2
#define MSGBOX_CONTINUE      3
#define MSGBOX_CANCEL        4

// =======================================================
class CInterface
{
public:
  CInterface(BOOL bBatchMode) {m_bBatchMode = bBatchMode;} 
  virtual ~CInterface() {} 

  // defined in herited classes
  virtual void msgBoxOk(char *szTitle, char *szText, ...)=0;
  virtual void msgBoxCancel(char *szTitle, char *szText, ...)=0;
  virtual void msgBoxError(char *szText, ...)=0;
  virtual int msgBoxYesNo(char *szTitle, char *szText, ...)=0;
  virtual int msgBoxContinueCancel(char *szTitle, char *szText, ...)=0;
  virtual void showErrorInternal(char *szText)=0;

  // defined in the base class
  void showError(signed int nErr, char *szFormat, ...);

  void showAboutDialog();

private:
  BOOL m_bBatchMode;
};

#endif
