/***************************************************************************
                          interface_base.cpp  -  description
                             -------------------
    begin                : Wed Mar 14 2001
    copyright            : (C) 2001 by Franck Ladurelle
    email                : ladurelf@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#include "interface.h"
#include <string.h>
#include <stdlib.h>

// =======================================================
void CInterface::showError(signed int nErr, char *szFormat, ...)
{
  va_list args;
  char szText[4096];

  // format text
  va_start(args, szFormat);
  vsnprintf(szText, sizeof(szText), szFormat, args);
  va_end(args);

  showDebug(1, "showError: [%s]\n", szText);

  if (!m_bBatchMode)
    msgBoxCancel(i18n("Error"), "%s", szText);
}

// =======================================================
void CInterface::showAboutDialog()
{
  char szTitle[128];
  
  SNPRINTF(szTitle, i18n("About Partition Image %s"), VERSION);
  
  msgBoxOk(szTitle, i18n("Partition Image is distributed under the GNU GPL 2"
     " (General Public License)\n\n"
     "version:...%s\n"
     "web:.......http://www.partimage.org/\n\n"
     "Authors:\nFranois Dupoux <fdupoux@partimage.org>\n"
     "Franck Ladurelle <ladurelf@partimage.org>"), VERSION);
}
