#include "formDialogFormat.h"
#include "pipushbutton.h"
#include "common.h"

#include <qlabel.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qcombobox.h>
#include <qlineedit.h>

//------------------------------------------------
CFormatDialog::CFormatDialog(char *szDevice, QStrList *strlFs, QString strOldFs, QWidget* parent, const char* name, bool modal, WFlags fl ) : 
   QDialog(parent, name, modal, fl)
{
   // init
   m_strlFs = strlFs;
   m_strFs = strlFs->first();
   m_strDevice.sprintf("%s", szDevice);

   initDialog(strlFs, strOldFs);
   showInfos();

   connect(m_comboFs, SIGNAL(activated(int)), this, SLOT(slotChanged()));
   connect(m_editLabel, SIGNAL(textChanged(const QString &)), this, SLOT(slotChanged()));
   connect(m_btnOk, SIGNAL(clicked()), this, SLOT(slotOk()));
   connect(m_btnCancel, SIGNAL(clicked()), this, SLOT(reject()));
}

//------------------------------------------------
void CFormatDialog::initDialog(QStrList *strlFs, QString strOldFs)
{
   QString strTemp;
   resize(100, 100);
   setCaption( trUtf8( "Format a partition" ) );

   m_lay = new QGridLayout (this, 5/*row*/, 2/*col*/, 0, 10);
   m_lay -> setMargin(15);

   m_labelDevice1 = new QLabel(this, "m_labelDevice1");
   m_labelDevice1 -> setText("Device:");
   m_lay -> addMultiCellWidget (m_labelDevice1, 0, 0, 0, 0);

   m_labelDevice2 = new QLabel(this, "m_labelDevice2");
   m_labelDevice2 -> setText(m_strDevice);
   m_lay -> addMultiCellWidget (m_labelDevice2, 0, 0, 1, 1);

   m_labelOldFs1 = new QLabel(this, "m_labelOldFs1");
   m_labelOldFs1 -> setText("Old file system:");
   m_lay -> addMultiCellWidget (m_labelOldFs1, 1, 1, 0, 0);

   m_labelOldFs2 = new QLabel(this, "m_labelOldFs2");
   m_labelOldFs2 -> setText(strOldFs);
   m_lay -> addMultiCellWidget (m_labelOldFs2, 1, 1, 1, 1);

   m_labelFs = new QLabel(this, "m_labelFs");
   m_labelFs -> setText("New file system:");
   m_lay -> addMultiCellWidget (m_labelFs, 2, 2, 0, 0);

   m_comboFs = new QComboBox(this, "m_comboFs");
   for (strTemp = strlFs->first(); strTemp; strTemp = strlFs->next() )
      m_comboFs -> insertItem(strTemp);
   m_lay -> addMultiCellWidget (m_comboFs, 2, 2, 1, 1);

   m_labelLabel = new QLabel(this, "m_labelLabel");
   m_labelLabel -> setText("New label:");
   m_lay -> addMultiCellWidget (m_labelLabel, 3, 3, 0, 0);

   m_editLabel = new QLineEdit(this, "m_editLabel");
   m_editLabel -> setMaxLength (11);
   m_lay -> addMultiCellWidget (m_editLabel, 3, 3, 1, 1);

   m_btnOk = new COkButton(this,"m_btnOk");
   m_lay -> addMultiCellWidget (m_btnOk, 4, 4, 0, 0);
  
   m_btnCancel = new CCancelButton(this,"m_btnCancel");
   m_lay -> addMultiCellWidget (m_btnCancel, 4, 4, 1, 1);
}

//------------------------------------------------
CFormatDialog::~CFormatDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

//------------------------------------------------
void CFormatDialog::slotOk()
{
  // Check the Search text is not empty
  /*if (not good)
    {
    error
    return;
    }*/
  
  // Copy text into variables
  //m_strSearch = m_editSearch -> text();
  //m_strReplace = m_editReplace -> text();
  
  accept();
}

//------------------------------------------------
void CFormatDialog::slotChanged()
{
   QString strPrimary, strExtended, strLogical;

   m_strFs = m_comboFs->currentText();
   m_strLabel = m_editLabel->text();
}

//------------------------------------------------
void CFormatDialog::getResults(char *szFs, int nFsLen, char *szLabel, int nLabelLen)
{
   snprintf(szFs, nFsLen, "%s", m_strFs.latin1());
   snprintf(szLabel, nLabelLen, "%s", m_strLabel.latin1());
}

//------------------------------------------------
void CFormatDialog::showInfos()
{
}

#include "formDialogFormat.moc"
