#ifndef CFORMATDIALOG_H
#define CFORMATDIALOG_H

#include "global.h"

#include <qvariant.h>
#include <qdialog.h>
#include <qstring.h>

class QGridLayout; 
class QLabel;
class QPushButton;
class QComboBox;
class QStrList;
class QLineEdit;
class COkButton;
class CCancelButton;

//------------------------------------------------
class CFormatDialog : public QDialog
{ 
  Q_OBJECT

    public:
  CFormatDialog(char *szDevice, QStrList *strlFs, QString strOldFs, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  ~CFormatDialog();

 public:
  void initDialog(QStrList *strlFs, QString strOldFs);
  void showInfos();
  void getResults(char *szFs, int nFsLen, char *szLabel, int nLabelLen);

  public slots:
    void slotChanged();

 private:
  QGridLayout *m_lay;

  QLabel *m_labelDevice1;
  QLabel *m_labelDevice2;

  QLabel *m_labelOldFs1;
  QLabel *m_labelOldFs2;  

  QLabel *m_labelFs;
  QLabel *m_labelLabel;

  QLineEdit *m_editLabel;
  QComboBox *m_comboFs;

  COkButton *m_btnOk;    
  CCancelButton *m_btnCancel;  

  public slots:
    void slotOk();

 private:
  QString m_strDevice;
  QString m_strFs; // current selected FS
  QString m_strLabel; // current label
  QStrList *m_strlFs; // list with all FS
};

#endif // CFORMATDIALOG_H
