#ifndef CPARTEDCREATEDIALOG_H
#define CPARTEDCREATEDIALOG_H

#include "global.h"

#include <qvariant.h>
#include <qdialog.h>
#include <qstring.h>

class QGridLayout; 
class QButtonGroup;
class QLabel;
class QPushButton;
class QSlider;
class QComboBox;
class COkButton;
class CCancelButton;
class QLineEdit;

//------------------------------------------------
class CPartedCreateDialog : public QDialog
{ 
  Q_OBJECT

    public:
  CPartedCreateDialog(char *szDevice, QStrList *strlFs, DWORD dwMinStart, DWORD dwMaxEnd, BOOL bCanMakeExtended, BOOL bCanMakePrimary, BOOL bCanMakeLogical, 
		      QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  ~CPartedCreateDialog();

 public:
  void initDialog(BOOL bCanMakeExtended, BOOL bCanMakePrimary, BOOL bCanMakeLogical);
  void showInfos();
  int  getResults(DWORD *dwSectStart, DWORD *dwSectEnd, DWORD *dwPartType, char *szFs, int nMaxFsLen, char *szLabel, int nMaxLabelLen);

  public slots:
    void slotChanged();

 private:
  QGridLayout *m_lay;
  QLabel *m_labelDevice1;
  QLabel *m_labelDevice2;
  QLabel *m_labelTitle1;
  QLabel *m_labelTitle2;
  QLabel *m_labelStart1;
  QLabel *m_labelEnd1;
  QLabel *m_labelSize1;
  QLabel *m_labelStart2;
  QLabel *m_labelEnd2;
  QLabel *m_labelSize2;
  QLabel *m_labelStart3;
  QLabel *m_labelEnd3;
  QLabel *m_labelSize3;
  QLabel *m_labelSize4;
  
  QLabel *m_labelFs;
  QComboBox *m_comboFs;

  QLabel *m_labelLabel;
  QLineEdit *m_editLabel;

  QSlider *m_slider;

  QComboBox *m_comboPartType;
  QLabel *m_labelType;

  QComboBox *m_comboPartPos;
  QLabel *m_labelPos;
  
  COkButton *m_btnOk;    
  CCancelButton *m_btnCancel;  

  public slots:
    void slotOk();

 private:
  QString m_strFs;
  QString m_strLabel;
  QStrList *m_strlFs;
  QString m_strDevice;
  DWORD m_dwMinStart;
  DWORD m_dwMaxEnd;
  DWORD m_dwStart;
  DWORD m_dwEnd;
  DWORD m_dwPartType;
};

#endif // CPARTEDCREATEDIALOG_H
