#ifndef CDIALOGPISAVE_H
#define CDIALOGPISAVE_H

#include "global.h"

#include <qvariant.h>
#include <qdialog.h>
#include <qstring.h>

class QGridLayout; 
class QButtonGroup;
class QLabel;
class QPushButton;
class QSlider;
class QComboBox;
class QRadioButton;
class QCheckBox;
class COkButton;
class CCancelButton;
class QSpinBox;
class QTextEdit;
struct COptions;

//------------------------------------------------
class CPiSaveDialog : public QDialog
{ 
  Q_OBJECT

    public:
  CPiSaveDialog(char *szDevice, COptions *options, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0);
  ~CPiSaveDialog();

 public:
  void initDialog();
  int getResults(char *szImagefile, int nMaxImageLen, char *szDevice, int nMaxDeviceLen, char *szDesc, int nMaxDescLen, COptions *options);

 private:
  QGridLayout *m_lay;

  QLabel *m_labelDevice1;
  QLabel *m_labelDevice2;

  QLabel *m_labelImagefile1;
  QLabel *m_labelImagefile2;
  QPushButton *m_btnSelectFile;
  
  QButtonGroup *m_bgCompress;
  QRadioButton *m_radioCompress1;
  QRadioButton *m_radioCompress2;
  QRadioButton *m_radioCompress3;
  QRadioButton *m_radioCompress4;

  QButtonGroup *m_bgOptions;
  QCheckBox *m_checkCheckPart;
  //QCheckBox *m_checkDesc;
  QCheckBox *m_checkOverwrite;

  QButtonGroup *m_bgSplit;
  QRadioButton *m_radioSplit1;
  QRadioButton *m_radioSplit2;
  QSpinBox *m_spinSplitSize;
  QLabel *m_labelSplit;
  
  QTextEdit *m_editDesc;
  QButtonGroup *m_bgDesc;

  COkButton *m_btnOk;    
  CCancelButton *m_btnCancel;  

  public slots:
    void slotOk();
  void slotSelect();
  void slotSelectSplit1();
  void slotSelectSplit2();

 private:
  COptions *m_options;
  QString m_strDevice;
  QString m_strImageFile;
  QString m_strDesc;
};

#endif // CDIALOGPISAVE_H
