#ifndef CRESIZEDIALOG_H
#define CRESIZEDIALOG_H

#include "global.h"

#include <qvariant.h>
#include <qdialog.h>
#include <qstring.h>

class QGridLayout; 
class QButtonGroup;
class QLabel;
class QPushButton;
class QSlider;
class QComboBox;
class COkButton;
class CCancelButton;
class QLineEdit;

#define POSITION_BEGIN       0
#define POSITION_END         1

#define MAX_PARTSIZE_SECTORS 2048 // 1 MB = 512*2048
#define SECTOR_SIZE          512LL

//------------------------------------------------
class CResizeDialog : public QDialog
{ 
  Q_OBJECT

    public:
  CResizeDialog(char *szDevice, DWORD dwStart, DWORD dwMinSize, DWORD dwMaxEnd, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  ~CResizeDialog();

 public:
  void initDialog();
  void showInfos();
  int  getResults(DWORD *dwSectEnd);

  public slots:
    void slotChanged();

 private:
  QGridLayout *m_lay;
  QLabel *m_labelDevice1;
  QLabel *m_labelDevice2;
  QLabel *m_labelTitle1;
  QLabel *m_labelTitle2;
  QLabel *m_labelStart1;
  QLabel *m_labelEnd1;
  QLabel *m_labelSize1;
  QLabel *m_labelStart2;
  QLabel *m_labelEnd2;
  QLabel *m_labelSize2;
  QLabel *m_labelStart3;
  QLabel *m_labelEnd3;
  QLabel *m_labelSize3;
  QLabel *m_labelSize4;
  
  QSlider *m_slider;

  COkButton *m_btnOk;    
  CCancelButton *m_btnCancel;  

  public slots:
    void slotOk();

 private:
  QString m_strFs;
  QString m_strLabel;
  QStrList *m_strlFs;
  QString m_strDevice;
  DWORD m_dwMaxEnd;
  DWORD m_dwMinSize;
  DWORD m_dwStart;
  DWORD m_dwEnd;
  DWORD m_dwPartType;
};

#endif // CRESIZEDIALOG_H
