/***************************************************************************
                          piguicqt.h  -  description
                             -------------------
    begin                : Wed Sep  4 19:21:54 UTC 2002
    copyright            : (C) 2002 by Francois Dupoux
    email                : fdupoux@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PIGUICQT_H
#define PIGUICQT_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>

// application specific includes
#include "piguicqtview.h"
#include "piguicqtdoc.h"

class CNewNet;

//------------------------------------------------
class PiguicqtApp : public QMainWindow
{
  Q_OBJECT
  
    public:
  PiguicqtApp(QApplication *app, char *szServerName, WORD wServerPort, COptions *options);
  ~PiguicqtApp();
  void initActions();
  void initMenuBar();
  void initToolBar();
  void initStatusBar();
  void initDoc(char *szServerName, WORD wServerPort, COptions *options);
  void initView();
  QPopupMenu *getContextMenu() {return m_contextMenu;}
  PiguicqtView *getView() {return m_view;}
  QApplication *getApp() {return m_app;}
  
  bool queryExit();

 protected:
  virtual void closeEvent ( QCloseEvent * e );

  public slots:

    void slotFileQuit();
  void slotViewToolBar(bool toggle);
  void slotViewStatusBar(bool toggle);

  /** shows an about dlg*/
  void slotHelpAbout();
  void slotHelpAboutQt();

  public slots:
    void exitNow();
  void makeStyle(const QString &style);

 public:
  COptions *getOptions() {return m_options;}
  void grayActions(BOOL bOperationInProgress=false);
  void waitDuringOperation(CNewNet *net);

 private:
  QApplication *m_app;
  PiguicqtView *m_view;
  PiguicqtDoc *m_doc;
  COptions *m_options;

  QPopupMenu *m_contextMenu;

  QPopupMenu *m_fileMenu;
  QPopupMenu *m_viewMenu;
  QPopupMenu *m_helpMenu;

  QToolBar *m_fileToolbar;

  QAction *m_fileQuit;

  QAction *m_operLabel;
  QAction *m_operCreate;
  QAction *m_operFormat;
  QAction *m_operResize;
  QAction *m_operDelete;
  QAction *m_operPiSave;
  QAction *m_operPiRestore;
  QAction *m_operPiCopy;
  QAction *m_operProperties;
  QAction *m_operRefresh;

  QAction *m_viewToolBar;
  QAction *m_viewStatusBar;

  QAction *m_helpAboutApp;
  QAction *m_helpAboutQt;
};
#endif 

