/***************************************************************************
                          piguicqtdoc.h  -  description
                             -------------------
    begin                : Wed Sep  4 19:21:54 UTC 2002
    copyright            : (C) 2002 by Francois Dupoux
    email                : fdupoux@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef PIGUICQTDOC_H
#define PIGUICQTDOC_H

#include <qobject.h>

#include "workserver.h"

class CNewNet;
class CPartInfo;
class PiguicqtApp;
class PiguicqtView;

#define MAX_DRIVES 128

//------------------------------------------------
struct CDriveDoc
{
  CDiskInfo dinfo;
  CPartInfo *piInfo[MAX_PARTS];
  DWORD dwPartsCount;
};

//------------------------------------------------
class PiguicqtDoc : public QObject
{
  Q_OBJECT

    public:
  PiguicqtDoc(QWidget *parent, char *szServerName, WORD wServerPort, COptions *options);
  ~PiguicqtDoc();

 private:
  void refreshDisk(int nDisk);
  int  recvDiskInfos(CDriveDoc *drives);

 private:
  CNewNet *m_net;
  CDriveDoc *m_drives[MAX_DRIVES];
  DWORD m_dwDrivesCount;
  COptions *m_options;
  PiguicqtApp *m_app;

 public:
  void sendExit();
  int initDrives();
  int umountPart(char *szPart);
  int checkPartNotMounted(char *szPart);
  BOOL isPartUsed(int nDrive, int nPart);
  COptions *getOptions() {return m_options;}
  DWORD getDrivesCount() {return m_dwDrivesCount;}
  char *getDriveName(int nId) {return m_drives[nId]->dinfo.szDiskName;}
  DWORD getPartsCount(int nId) {return m_drives[nId]->dwPartsCount;}
  CPartInfo *getPartInfo(int nDisk, int nPart) {return (m_drives[nDisk]->piInfo[nPart]);}
  QWORD getDriveSize(int nDisk) {return m_drives[nDisk]->dinfo.qwDiskSize;}
  PiguicqtView *getView();
  PiguicqtApp *getApp() {return m_app;}

  public slots:
    void slotOperLabel();
  void slotOperCreate();
  void slotOperFormat();
  void slotOperResize();
  void slotOperDelete();
  void slotOperPiSave();
  void slotOperPiRestore();
  void slotOperPiCopy();
  void slotOperRefresh();
  void slotOperProperties();
};

#endif
