/***************************************************************************
                          piguicqtview.h  -  description
                             -------------------
    begin                : Wed Sep  4 19:21:54 UTC 2002
    copyright            : (C) 2002 by Francois Dupoux
    email                : fdupoux@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PIGUICQTVIEW_H
#define PIGUICQTVIEW_H

// include files for QT
#include <qwidget.h>
#include <qtabwidget.h>
#include <qptrvector.h>
#include <qpushbutton.h>

// application specific includes
#include "piguicqtdoc.h"

class QVBox;
class QHBoxLayout;
class QListView;
class QTab;
class QListViewItem;
class QPushButton;
class PiguicqtApp;
class QHBox;
class CPiPushButton;

typedef QPtrVector<CPiPushButton> CPiPushButtons;

//------------------------------------------------
struct CDriveView
{
  QVBox *vbox; // contains buttons+list
  QHBox *hBoxBtnBar; // buttons
  QHBox *hBoxSummary; // infos about the whole hard disk
  QListView *lv; // list
  CPiPushButton *m_pbItem[MAX_PARTS];
  QListViewItem *m_lviItem[MAX_PARTS];
  CPiPushButtons *m_btnList;
};

//------------------------------------------------
class PiguicqtView : public QTabWidget
{
  Q_OBJECT

    public:
  PiguicqtView(QWidget *parent=0, PiguicqtDoc* doc=0);
  ~PiguicqtView();

 public:
  int setCurrentPart(int nDrive, int nPart);
  COptions *getOptions();
  PiguicqtApp *getApp() {return m_app;}
  void getCurrentDiskPart(int *nDisk, int *nPart);
  int refreshDisk(int nDisk);
  int createTab(CDriveView *drive, int nTabPos);

  protected slots:
    void slotDocumentChanged();
  void mouseReleaseEvent(QMouseEvent *);
  void slotButtonBarClicked();
  void slotListViewClickedLeft(QListViewItem *);

 private:
  PiguicqtApp *m_app;
  CDriveView *m_drive[MAX_DRIVES];
  PiguicqtDoc* m_doc;
  int m_nDrive;
  int m_nPart;
};


#endif
