/***************************************************************************
                        pipushbutton.cpp  -  description
                             -------------------
    begin                : Wed Sep  4 19:21:54 UTC 2002
    copyright            : (C) 2002 by Francois Dupoux
    email                : fdupoux@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pipushbutton.h"
#include "common.h"

#include <qpainter.h>
#include <string.h>
#include <qcolor.h>
#include <parted/parted.h>

#define dwmax(a,b) ( ((long int)(a)>(long int)(b)) ? (a) : (b) )

//------------------------------------------------
COkButton::COkButton(QWidget *parent, const char * name): QPushButton(parent, name)
{
   setText("OK (F5)");
   setAccel ( QKeySequence(Key_F5) );
}

//------------------------------------------------
COkButton::~COkButton()
{


}

//------------------------------------------------
CCancelButton::CCancelButton(QWidget *parent, const char * name): QPushButton(parent, name)
{
   setText("Cancel (F6)");
   setAccel ( QKeySequence(Key_F6) );
}

//------------------------------------------------
CCancelButton::~CCancelButton()
{


}

//------------------------------------------------
CPiPushButton::CPiPushButton(CPartInfo info, QWidget *parent) : QPushButton(parent)
{
   m_info = info;
}

//------------------------------------------------
void CPiPushButton::drawButtonLabel(QPainter *p)
{
   QRect r = rect();
   DWORD dwTotalWidth = r.width()-((2*MARGINX)+(2*TOUR));
   DWORD dwTotalHeight = r.height()-((2*MARGINY)+(2*TOUR));
   DWORD dwUsedWidth = (dwTotalWidth * m_info.dwPctUsage) / 100L;
   QString strText;
   QSize sizeText;
   char szTemp[128];
   QPoint pt;

   QFontMetrics fm = p->fontMetrics();
   
   if (m_info.dwType != PED_PARTITION_FREESPACE) // if used
   {
      // draw file system color
      p -> setPen( QPen(black, 1 ) );
      p -> setBrush (QBrush( QColor(m_info.cColorRed, m_info.cColorGreen, m_info.cColorBlue).rgb() ));
      p -> drawRect (r.left()+MARGINX,  r.top()+MARGINY, r.width()-(2*MARGINX),  r.height()-(2*MARGINY));

      // draw whole space (white)
      p -> setPen( QPen(gray, 1 ) );
      p -> setBrush (QBrush(white) );
      p -> drawRect (r.left()+MARGINX+TOUR,  r.top()+MARGINY+TOUR, r.width()-(2*MARGINX)-(2*TOUR),  r.height()-(2*MARGINY)-(2*TOUR));

      // draw used space (yellow)
      QColor color(0xFF, 0xFF, 0xBB);
      p -> setPen( QPen(gray, 1 ) ); 
      p -> setBrush (QBrush(color) );
      p -> drawRect (r.left()+MARGINX+TOUR,  r.top()+MARGINY+TOUR, r.left()+dwUsedWidth, r.height()-(2*MARGINY)-(2*TOUR));
      strText.sprintf("%s (%s)", m_info.szPartName+strlen("/dev/"), formatSize(m_info.qwSize, szTemp));
   }
   else // if free
   {
      strText.sprintf("Free space");
   }

   // draw text
   p -> setPen( QPen(black, 1 ) ); 
   sizeText = fm.size(SingleLine, strText.data());

   if ((int)sizeText.width() > (int)dwTotalWidth) // text too large
   {
      if (m_info.dwType != PED_PARTITION_FREESPACE) // if used
	 strText.sprintf("%s", m_info.szPartName+strlen("/dev/"));
      else // if free
	 strText.sprintf("Free");
      sizeText = fm.size(SingleLine, strText.data());
   }

   pt.setX ((r.left()+MARGINX+TOUR)+(dwTotalWidth/2)-(sizeText.width()/2));
   pt.setY ((r.top()+MARGINY+TOUR)+(dwTotalHeight/2)+(sizeText.height()/2));
   p -> drawText (pt, strText);
}


