/***************************************************************************
                          modules.cpp  -  
                             -------------------
    begin                : Fri Jul 27 2001
    copyright            : (C) 2001 by Franck Ladurelle
    email                : ladurelf@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#ifdef HAVE_GETOPT_H
  #include <getopt.h>
#endif

#ifdef HAVE_SYS_PARAM_H
  #include <sys/param.h>
#endif

#include <stdlib.h>
#include <unistd.h>

#include "global.h"
#include "workserver.h"

#ifdef HAVE_GETOPT_H
static struct option const long_options[] =
{
  {"help", no_argument, NULL, 'h'},
  {"version", no_argument, NULL, 'v'},
  //{"server", required_argument, NULL, 's'},
  {"port", required_argument, NULL, 'p'},
  {NULL, 0, NULL, 0}
};
#endif

static char optstring[]="hvp:";
FILE *g_fDebug; // debug file
FILE *g_fLocalDebug; // debug file
CInterfaceNewt* g_interface;
BOOL g_bSigInt = false;
BOOL g_bSigKill = false;
QWORD g_qwCopiedBytesCount=0;

// =======================================================
int main(int argc, char *argv[])
{
   int nOptCh;
    
   //char szServerName[1024];
   DWORD dwServerPort;

   // init options with default values
   //snprintf(szServerName, sizeof(szServerName), "%s", "127.0.0.1");
   dwServerPort = PARTIMAGE_GUI_PORT;

   // initialize language for i18n
   //setlocale(LC_ALL, "");
   //bindtextdomain (PACKAGE, LOCALEDIR);
   //textdomain (PACKAGE);
  
   // read command line
#ifdef HAVE_GETOPT_H
   while ((nOptCh = getopt_long (argc, argv, optstring, long_options, NULL)) != EOF)
#else
      while ((nOptCh = getopt (argc, argv, optstring)) != -1)
#endif
      {
	 switch(nOptCh)
	 {
	    //case 's': // partimaged server's ip addr
	    //strncpy(szServerName, optarg, MAX_HOSTNAMESIZE);
	    //break;
	    case 'p': // partimaged server's listening port
	       dwServerPort = atol(optarg);
	       if ((dwServerPort < 1) || (dwServerPort > 65535))
	       {	
		  fprintf(stderr, i18n("server's port must be between 1 and 65535\n"));
		  return EXIT_FAILURE;
	       }
	       break;

	    case 'h': // help
	    case 'v': // version
	       printf(i18n("Partition Image GUI server version %s (distributed under the GNU GPL2).\n"), VERSION);
	       return EXIT_SUCCESS;
	       break;
	 }
      }

   // run the server
   serverapp(dwServerPort);

   return EXIT_SUCCESS;
}
