/***************************************************************************
              fs_unknown.cpp  -  Others File System Support
                             -------------------
    begin                : Thu Jul 13 2000
    copyright            : (C) 2000 by Franois Dupoux
    email                : fdupoux@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "fs_unknown.h"
#include "global.h"
#include "imagefile.h"

#include <string.h>

// =======================================================
CUnknownPart::CUnknownPart(char *szDevice, FILE *fDeviceFile, QWORD qwPartSize): CFSBase(szDevice, fDeviceFile, qwPartSize)
{
  BEGIN;
  RETURN;
}

// =======================================================
CUnknownPart::~CUnknownPart()
{
  BEGIN;
  RETURN;
}

// =======================================================
int CUnknownPart::fsck()
{
  BEGIN;
  RETURN_int(0);  
  // TODO: check for bad blocks
  // SUCCESS
}

// =======================================================
int CUnknownPart::readBitmap(/*COptions *options*/)
{
  BEGIN;

  QWORD i;

  // init bitmap
  m_bitmap.init(SGET(m_header,qwBitmapSize)+1024);

  for (i=0; i < SGET(m_header,qwBlocksCount); i++)
    m_bitmap.setBit(i, true);

  RETURN_int(0);  
}			

// =======================================================
int CUnknownPart::readSuperBlock()
{
  BEGIN;

  // init
  memset(&m_info, 0, sizeof(CInfoUnknownHeader));

  // block informations
  SPUT(m_header,qwBlockSize, 512);
  SPUT(m_header,qwBlocksCount, (m_qwPartSize) / SGET(m_header,qwBlockSize));
  SPUT(m_header,qwBitmapSize, (SGET(m_header,qwBlocksCount)+7)/8); // round up
  SPUT(m_header,qwUsedBlocks, SGET(m_header,qwBlocksCount));

  RETURN_int(0);  
}


// =======================================================
void CUnknownPart::printfInformations()
{
  BEGIN;

  char szText[8192];
  
  getStdInfos(szText, sizeof(szText), true);
//  g_interface->msgBoxOk(i18n("informations"), szText);

  RETURN;
}			


		



