/***************************************************************************
                          creiserpart.h  -  description
                             -------------------
    begin                : Thu Jul 13 2000
    copyright            : (C) 2000 by Franois Dupoux
    email                : fdupoux@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FS_UNKNOWN_H
#define FS_UNKNOWN_H

#include "global.h"
#include "fs_base.h"

// ================================================
    struct CInfoUnknownHeaderVal
    {
      BYTE cNothing;
      //BYTE cReserved[16384]; // Adjust to fit with total header size
    } PACKED; 

struct CInfoUnknownHeader // size must be 16384 (adjust the reserved data)
{
  union
  {
    CInfoUnknownHeaderVal val;
    char cReserved[INFOS_STRUCT_SIZE];
  };
};

// ================================================
class CUnknownPart: public CFSBase
{
public:
  CUnknownPart(char *szDevice, FILE *fDeviceFile, QWORD qwPartSize);
  ~CUnknownPart();
  
  //static  int detect(BYTE *cBootSect, char *szFileSystem); 
  virtual void printfInformations();
  virtual int readBitmap(/*COptions *options*/);
  virtual int readSuperBlock();
  virtual int fsck();
  virtual void* getInfos() {return (void*)&m_info;}

 private:
  CInfoUnknownHeader m_info;
};

#endif // FS_UNKNOWN_H
