/***************************************************************************
                          messages.h  -  description
                             -------------------
    begin                : Mon Oct 30 2000
    copyright            : (C) 2000 by Franck Ladurelle
    email                : ladurelf@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _MESSAGES_H_
#define _MESSAGES_H_

#include <string.h>
#include <stdlib.h>

#include "misc.h"
#include "global.h"

#define MSG_OK 0
#define MSG_OPENW 1
#define MSG_WRITE 2
/// #define MSG_WRITEMAGIC 3
#define MSG_READMAGIC 4
#define MSG_READ 5
#define MSG_CLOSE 6
#define MSG_OPENR 7
#define MSG_ISSPLIT 8
#define MSG_GETERROR 9
#define MSG_ERROR 10
#define MSG_GETSPACE 11
/// #define MSG_UNWRITE 12
#define MSG_DOESFILEEXIST 13
#define MSG_GETDISKSPACEFILE 14
#define MSG_GETFILESIZE 15
#define MSG_MOUNTIMAGELOCATION 16
#define MSG_UMOUNTIMAGELOCATION 17
#define MSG_NEWOPTIONS 18

#define MSG_SET_CVS 20
#define MSG_SET_VN 21
//#define MSG_SET_C 22 
//#define MSG_SET_CRC 23 
#define MSG_SET_IS 24 
#define MSG_SET_IO 25 
#define MSG_SET_P 26 
#define MSG_SET_IF 27 
#define MSG_SET_OF 28 

#define MSG_GET_CVS 30
#define MSG_GET_VN 31
#define MSG_GET_C 32 
//#define MSG_GET_CRC 33 
#define MSG_GET_IS 34 
#define MSG_GET_IO 35 
#define MSG_GET_P 36 
#define MSG_GET_IF 37 
#define MSG_GET_OF 38 

#define MSG_QUIT 40





/* ====================================================
   == MG?_*: messages between piwork and GUI ==========
   ====================================================
   MGx_yyyy
   - x==(2k+1): x is odd -> ((MG1 == first message from the GUI) or (MG3 == answer to answer))
   - x==(2k+0): x is even -> (MG2 == answer to MG1)
   ==================================================== */

#define BEGIN2 1000
#define BEGIN3 2000

// Messages request [0-999] (GUI -> piworker)
#define MG1_QUIT                  0
#define MG1_RETRY                 1
#define MG1_SKIP                  2
#define MG1_SET_OPTIONS           3
#define MG1_GET_PARTLIST          4
#define MG1_SET_PARAM             5
#define MG1_SET_DESCRIPTION       6
#define MG1_OPERATION_BEGIN       7
#define MG1_INTERRUPTED           8
#define MG1_OKAY                  9
#define MG1_IGNORE               10

#define MG3_INTERRUPTED           (BEGIN3+0)
#define MG3_OKAY                  (BEGIN3+1)

// Messages answers [1000-(1<<15)] (piworker -> GUI)
#define MG2_OK                     (BEGIN2+0)
#define MG2_EOF                    (BEGIN2+1)
#define MG2_FAIL                   (BEGIN2+2)
#define MG2_QUIT                   (BEGIN2+3)
#define MG2_END                    (BEGIN2+4)
#define MG2_SET_PARTINFO_SAVE      (BEGIN2+5)
#define MG2_SET_PARTINFO_RESTORE   (BEGIN2+6)
#define MG2_SET_PARTINFO_IMGCONV   (BEGIN2+7)
#define MG2_SET_SHOWSTATS          (BEGIN2+8)  
#define MG2_UPDATE_PARTITION_SAVE  (BEGIN2+9)
#define MG2_UPDATE_IMAGE_SAVE     (BEGIN2+10)
#define MG2_UPDATEWIN_RESTORE     (BEGIN2+11)
#define MG2_UPDATEWIN_IMGCONV     (BEGIN2+12)
#define MG2_UPDATEWIN_RESTMBR     (BEGIN2+13)

#define MG2_ERR_COMPRESSFAILED    (BEGIN2+14)
#define MG2_ERR_DECOMPRESSFAILED  (BEGIN2+15)

#define MG2_WAIT_REQUIRED         (BEGIN2+16)
#define MG2_GET_NEWPATH           (BEGIN2+17)

#define MG2_ERR_NOMEM             (BEGIN2+18)
#define MG2_ERR_CRCMISMATCH       (BEGIN2+19)








#define OFF_SIZE (sizeof(DWORD))
#define MESSAGE_LEN (OFF_SIZE + sizeof(DWORD))



class CMessages
{
private:
  char msg[sizeof(DWORD)+sizeof(DWORD)];

public:
  CMessages() {}

  void setMessage(DWORD _cmd);
  void setMessage(DWORD _cmd, DWORD _size);
  void getMessage(DWORD *_cmd, DWORD *_size);

  DWORD getCmd()
    { DWORD * aux = (DWORD *) malloc (sizeof(DWORD));
      memcpy(aux, msg, sizeof(DWORD));
      return *aux;
    }
      
  DWORD getSize()
    { DWORD * aux = (DWORD *) malloc (sizeof(DWORD));
      memcpy(aux, msg+OFF_SIZE, sizeof(DWORD));
      return *aux;
    }
  char * toString() { return msg; }
  void fromString(char * _msg) { memcpy(msg, _msg, MESSAGE_LEN); }
};


#endif // _MESSAGES_H_
