/***************************************************************************
                            net.h  -  description
                             -------------------
    begin                : Wed Sep  4 19:21:54 UTC 2002
    copyright            : (C) 2002 by Francois Dupoux
    email                : fdupoux@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __NET_H_
#define __NET_H_

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <unistd.h>

class CResult;

//------------------------------------------------
class CNewNet
{
 public:
  CNewNet(char *szCnxName);
  ~CNewNet();

  int	recv (void *buf, u32 len);
  int	send (void *buf, u32 len);
  int   recv_string (void *buf);
  int	recv_string (void *buf, u32 *len);
  int	send_string (void *buf);
  int	send_string (void *buf, u32  len);
  int   send_result(CResult *res);
  int   recv_result(CResult *res);

  int   init (u16 port);
  int   connect (const char *szAddr, u16 port, char *szBanner, char *szVersion);
  int	closeSock() {return (close(m_sock));}
  int   accept (int nPort, char *szBanner, char *szVersion);
  int   messageToRead();

  u8    recv_u8();
  u16   recv_u16();
  u32   recv_u32();
  u64   recv_u64();
  s32   send_u8(u8 a);
  s32   send_u16(u16 a);
  s32   send_u32(u32 a);
  s32   send_u64(u64 a);

  s8    recv_s8();
  s16   recv_s16();
  s32   recv_s32();
  s64   recv_s64();
  s32   send_s8(s8 a);
  s32   send_s16(s16 a);
  s32   send_s32(s32 a);
  s32   send_s64(s64 a);
  
 protected:
  pid_t    m_myPid;
  int      m_sock;
  int      m_sockConnect;
  struct sockaddr_in	m_localSa;
  char     m_szCnxName[256];
  QWORD    m_qwBytesIn;
  QWORD    m_qwBytesOut;
};

#endif // __NET_H_
