/***************************************************************************
                         workserver.h  -  description
                             -------------------
    begin                : Wed Sep  4 19:21:54 UTC 2002
    copyright            : (C) 2002 by Francois Dupoux
    email                : fdupoux@partimage.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _WORKSERVER_H
#define _WORKSERVER_H

class CNewNet;
class CLocalHeader;

#define MAX_NEWPARTS    32
#define MAX_PARTS       64

#include "global.h"
#include "format.h"

#define MAGIC_INFOGUI "MaZiC"

#define PIGUI_BANNER_TEXT "PiGUIcQt"
#define PIGUI_BANNER_VERSION "0.1.2"

#define MIN_SECTORS_IN_HOLE 4096 // 2 MB

//------------------------------------------------
struct CFileSys
{
  char szName[128];
  BOOL bJournalized;
  DWORD dwNumber;
  char szDesc[64];
  BYTE cColorRed;
  BYTE cColorGreen;
  BYTE cColorBlue;
  char szFsTools[128];
  char szCmdMkfsName[64];
  char szCmdMkfsOpts[64];
  char szCmdMkfsLabelOpts[64];
};

//------------------------------------------------
struct CPartInfo
{
  char szMagic[6];
  char szPartName[1024];
  char szMountPoint[2048];
  u32  dwMinor;
  u32  dwFileSystem;
  char szFilesysName[512];
  DWORD dwFileSystemType;
  BYTE cColorRed;
  BYTE cColorGreen;
  BYTE cColorBlue;
  DWORD dwPctUsage;
  DWORD dwP1000Disk;
  DWORD dwType;
  QWORD qwGeomStart;
  QWORD qwGeomEnd;  
  QWORD qwSize;
  u32 dwFlags;
  DWORD dwPosition;
  CLocalHeader headInfo;
  BOOL bInsideExtended;
};

//------------------------------------------------
struct CDiskInfo
{
  char szDevice[1024];
  char szDiskName[1024];
  QWORD qwDiskSize;
  BOOL bExtendedExists;
  DWORD dwPrimaryCount;
  CPartInfo piExtended;
};

extern CFileSys g_fs[];

void serverapp(int nPort);
void getPartDetails(CNewNet *net);
void isMounted(CNewNet *net);
void unmountPart(CNewNet *net);
void getHdList(CNewNet *net);
void getFsList(CNewNet *net);
void getHdListForOneDisk(CNewNet *net);
int getHdListDoDisk(/*PedDevice*/ void *device, BOOL bShowDetails);
void sortTable(CPartInfo *pinfo, DWORD dwInfoCount);
DWORD addFreeSpace(CDiskInfo di, CPartInfo *pinfo, DWORD dwInfoCount, QWORD qwDiskSize);
int getDeviceInfos(CLocalHeader *info, char *szDevice, char *szFileSystem, QWORD qwPartSize);
BOOL isSpaceInsideExtended(CDiskInfo di, DWORD dwSpaceSectorStart, DWORD dwSpaceSectorEnd);

#endif // _WORKSERVER_H
